// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _LIBGNOMECANVASMM_LINE_H
#define _LIBGNOMECANVASMM_LINE_H

#include <glibmm.h>

/* $Id: line.hg,v 1.7 2002/04/04 14:04:33 aholzmann Exp $ */

/* line.h
 * 
 * Copyright (C) 1998 EMC Capital Management Inc.
 * Developed by Havoc Pennington <hp@pobox.com>
 *
 * Copyright (C) 1999 The Gtk-- Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <libgnomecanvasmm/item.h>
#include <libgnomecanvasmm/canvas-property.h>
#include <libgnomecanvas/gnome-canvas-line.h>
#include <libgnomecanvas/gnome-canvas-util.h>
#include <libgnomecanvas/libgnomecanvas.h>
#include <vector>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GnomeCanvasLine GnomeCanvasLine;
typedef struct _GnomeCanvasLineClass GnomeCanvasLineClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

namespace Gnome
{

namespace Canvas
{ class Line_Class; } // namespace Canvas

} // namespace Gnome
namespace Gnome
{

namespace Canvas
{

class GnomeGroup;

// Sample use of Gnome_CanvasPoints :

//   Gnome_CanvasPoints points;
//  
//   points.push_back(Art::Point(0, 0));
//   points.push_back(Art::Point(100,0));
//   points.push_back(Art::Point(0,100));
//   points.push_back(Art::Point(100,100));
//
//   line = new Gnome_CanvasLine(&m_canvasgroup,points);

//using std::vector;

/** Wrapper for GnomeCanvasPoints.
 * GnomeCanvasPoints is actually a BoxedType,
 * but this acts in a similar way, with the advantage of acting like a std::vector.
 */
class Points : public std::vector<Art::Point>
{
public:
  Points(size_type nbpoints = 0);
  explicit Points(GnomeCanvasPoints* castitem);
  ~Points();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef  GnomeCanvasPoints BaseObjectType;  //So that this works with tempaltes that are intended for normal BoxedTypes.
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  operator bool() const;
  virtual bool is_null() const;

  const GnomeCanvasPoints* gobj() const { return _gobj(); }
  GnomeCanvasPoints* gobj() { return _gobj(); }
  static GType get_type () { return GNOME_TYPE_CANVAS_POINTS; }

protected:
  GnomeCanvasPoints* _gobj() const;
  mutable GnomeCanvasPoints* points_;
  mutable bool owned_;
};


class Line : public Item
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef Line CppObjectType;
  typedef Line_Class CppClassType;
  typedef GnomeCanvasLine BaseObjectType;
  typedef GnomeCanvasLineClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~Line();

private:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  friend class CppClassType;
  static CppClassType line_class_;

  Line(const Line&);
  Line& operator=(const Line&); // not implemented

protected:
  explicit Line(GnomeCanvasLine* castitem);
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type() G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */
  GnomeCanvasLine* gobj()             { return (GnomeCanvasLine*)(gobject_); }
  const GnomeCanvasLine* gobj() const { return (GnomeCanvasLine*)(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


private:

public:
  explicit Line(Group& parent);
  Line(Group& parent, const Points& points);

  Glib::PropertyProxy<Points> property_points();

  Glib::PropertyProxy<Glib::ustring> property_fill_color();

  Glib::PropertyProxy<Gdk::Color> property_fill_color_gdk();

  Glib::PropertyProxy<guint> property_fill_color_rgba();

  Glib::PropertyProxy< Glib::RefPtr<Gdk::Drawable> > property_fill_stipple();

  Glib::PropertyProxy<guint> property_width_pixels();

  Glib::PropertyProxy<double> property_width_units();

  Glib::PropertyProxy<Gdk::CapStyle> property_cap_style();

  Glib::PropertyProxy<Gdk::JoinStyle> property_join_style();

  Glib::PropertyProxy<Gdk::LineStyle> property_line_style();

  Glib::PropertyProxy<bool> property_first_arrowhead();

  Glib::PropertyProxy<bool> property_last_arrowhead();

  Glib::PropertyProxy<bool> property_smooth();

  Glib::PropertyProxy<guint> property_spline_steps();

  Glib::PropertyProxy<double> property_arrow_shape_a();

  Glib::PropertyProxy<double> property_arrow_shape_b();

  Glib::PropertyProxy<double> property_arrow_shape_c();


};

} /* namespace Canvas */
} /* namespace Gnome */


namespace Glib
{
  /** @relates Gnome::Canvas::Line */
  Gnome::Canvas::Line* wrap(GnomeCanvasLine* object, bool take_copy = false);
}
#endif /* _LIBGNOMECANVASMM_LINE_H */

